/**
 * @packageDocumentation
 * @module RegistrationUIContext
 */
/// <reference types="react" />
import { RegistrationActions as DispatchActions } from './dispatchActions';
import { RegistrationUIActionsLegacy } from '../AuthUIContextProvider';
type RegistrationUIActionsLegacyFunction = () => RegistrationUIActionsLegacy;
type RegistrationUIActionsLegacyCreator = (injectedActions: RegistrationUIActionsLegacy, dispatch: React.Dispatch<DispatchActions>) => RegistrationUIActionsLegacyFunction;
/**
 * Implementation of actions for altering the global [[RegistrationUIState]] via [[RegistrationUIActionsLegacy]] calls.
 * Uses actions injected into the app to make network calls, and then updates the global state accordingly
 * using by dispatching [[RegistrationActions]] to the [[registrationReducer]].
 *
 * @param injectedActions Implementation of network activities.
 * @param dispatch For updating reducer upon completion of network activities.
 */
export declare const RegistrationActionsCreator: RegistrationUIActionsLegacyCreator;
export {};
