import React, { HTMLAttributes } from 'react';
import { SxProps, Theme } from '@mui/material/styles';
import { PasswordRequirement } from '../../new-architecture';
export type PasswordRequirementsProps = HTMLAttributes<HTMLDivElement> & {
    passwordText: string;
    passwordRequirements?: PasswordRequirement[];
    sx?: SxProps<Theme>;
};
/**
 * Component that renders all of the password requirement line items with check indicators.
 *
 * @param passwordText The string to conduct the complexity checks against
 * @param passwordRequirements Optional requirements to set password
 *
 * @category Component
 */
export declare const PasswordRequirements: React.FC<React.PropsWithChildren<PasswordRequirementsProps>>;
