/// <reference types="react" />
import { SxProps } from '@mui/material/styles';
export type ErrorMessageBoxProps = {
    errorMessage: string;
    backgroundColor?: string;
    dismissible?: boolean;
    fontColor?: string;
    onClose?: () => void;
    sx?: SxProps;
};
/**
 * Component that renders a basic message box with an error message and a configurable dismiss button.
 *
 * @param errorMessage text to show in the title
 * @param backgroundColor the background color of the message box
 * @param dismissible whether the message box can be dismissed
 * @param fontColor the font color of the text inside the message box
 * @param onClose function to call when the close button is clicked
 * @param sx sx styles passed to the underlying root(Box) component
 *
 * @category Component
 */
declare const ErrorMessageBox: (props: ErrorMessageBoxProps) => JSX.Element;
export default ErrorMessageBox;
