"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistrationWorkflow = void 0;
var react_1 = __importStar(require("react"));
var contexts_1 = require("../../contexts");
var screens_1 = require("../../screens");
var RegistrationWorkflow = function (props) {
    var _a = props.initialScreenIndex, initialScreenIndex = _a === void 0 ? 0 : _a, children = props.children, _b = props.successScreen, successScreen = _b === void 0 ? react_1.default.createElement(screens_1.RegistrationSuccessScreen, null) : _b;
    var screens = __spreadArray([], (Array.isArray(children) ? children : [children]), true);
    var totalScreens = screens.length;
    var _c = (0, react_1.useState)(initialScreenIndex < 0 ? 0 : initialScreenIndex > totalScreens - 1 ? totalScreens - 1 : initialScreenIndex), currentScreen = _c[0], setCurrentScreen = _c[1];
    var _d = (0, react_1.useState)(false), showSuccessScreen = _d[0], setShowSuccessScreen = _d[1];
    var actions = (0, contexts_1.useRegistrationContext)().actions;
    var _e = (0, react_1.useState)({
        Eula: {
            accepted: false,
        },
        CreateAccount: {
            emailAddress: '',
        },
        VerifyCode: {
            code: '',
        },
        CreatePassword: {
            password: '',
            confirmPassword: '',
        },
        AccountDetails: {
            firstName: '',
            lastName: '',
        },
        Other: {},
    }), screenData = _e[0], setScreenData = _e[1];
    var updateScreenData = function (data) {
        var Other = screenData.Other;
        var screenId = data.screenId, values = data.values;
        if (!Object.keys(screenData).includes(screenId)) {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), { Other: __assign(__assign({}, oldData.Other), (_a = {}, _a[screenId] = values, _a)) }));
            });
        }
        else if (Object.keys(Other).includes(screenId)) {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), { 
                    /* @ts-ignore */
                    Other: __assign(__assign({}, Other), (_a = {}, _a[screenId] = __assign(__assign({}, Other[screenId]), values), _a)) }));
            });
        }
        else {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), (_a = {}, _a[screenId] = values, _a)));
            });
        }
    };
    var finishRegistration = function () {
        var _a = screenData.AccountDetails, firstName = _a.firstName, lastName = _a.lastName;
        if (actions && actions().completeRegistration)
            return actions()
                .completeRegistration({ firstName: firstName, lastName: lastName }, screenData.VerifyCode.code, screenData.CreateAccount.emailAddress)
                .then(function (_a) {
                var email = _a.email, organizationName = _a.organizationName;
                updateScreenData({
                    screenId: 'RegistrationSuccessScreen',
                    values: { email: email, organizationName: organizationName },
                });
                setShowSuccessScreen(true);
            })
                .catch(function (_error) {
                // eslint-disable-next-line no-console
                console.log(_error);
            });
    };
    return (react_1.default.createElement(contexts_1.RegistrationWorkflowContextProvider, { currentScreen: currentScreen, totalScreens: totalScreens, nextScreen: function (data) {
            updateScreenData(data);
            if (currentScreen === totalScreens - 1)
                return finishRegistration();
            setCurrentScreen(function (i) { return i + 1; });
        }, previousScreen: function (data) {
            updateScreenData(data);
            setCurrentScreen(function (i) { return i - 1; });
        }, screenData: screenData, updateScreenData: updateScreenData }, showSuccessScreen ? successScreen : screens[currentScreen]));
};
exports.RegistrationWorkflow = RegistrationWorkflow;
