"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountDetailsScreenBase = void 0;
var react_1 = __importStar(require("react"));
var TextField_1 = __importDefault(require("@mui/material/TextField"));
var WorkflowCard_1 = require("../../components/WorkflowCard");
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
var AccountDetailsScreenBase = function (props) {
    var firstNameLabel = props.firstNameLabel, initialFirstName = props.initialFirstName, firstNameValidator = props.firstNameValidator, firstNameTextFieldProps = props.firstNameTextFieldProps, lastNameLabel = props.lastNameLabel, initialLastName = props.initialLastName, lastNameValidator = props.lastNameValidator, lastNameTextFieldProps = props.lastNameTextFieldProps, errorDisplayConfig = props.errorDisplayConfig;
    var cardBaseProps = props.WorkflowCardBaseProps || {};
    var headerProps = props.WorkflowCardHeaderProps || {};
    var instructionsProps = props.WorkflowCardInstructionProps || {};
    var actionsProps = props.WorkflowCardActionsProps || {};
    var firstNameRef = (0, react_1.useRef)(null);
    var lastNameRef = (0, react_1.useRef)(null);
    var _a = react_1.default.useState(initialFirstName ? initialFirstName : ''), firstNameInput = _a[0], setFirstNameInput = _a[1];
    var _b = react_1.default.useState(initialLastName ? initialLastName : ''), lastNameInput = _b[0], setLastNameInput = _b[1];
    var _c = react_1.default.useState(''), firstNameError = _c[0], setFirstNameError = _c[1];
    var _d = react_1.default.useState(''), lastNameError = _d[0], setLastNameError = _d[1];
    var _e = react_1.default.useState(false), showFirstNameError = _e[0], setShowFirstNameError = _e[1];
    var _f = react_1.default.useState(false), showLastNameError = _f[0], setShowLastNameError = _f[1];
    var _g = react_1.default.useState(false), isFirstNameValid = _g[0], setIsFirstNameValid = _g[1];
    var _h = react_1.default.useState(false), isLastNameValid = _h[0], setIsLastNameValid = _h[1];
    var _j = react_1.default.useState(false), isFormValid = _j[0], setIsFormValid = _j[1];
    var validateFirstName = (0, react_1.useCallback)(function (firstName) {
        var validatorResponse = firstNameValidator(firstName);
        setIsFirstNameValid(typeof validatorResponse === 'boolean' ? validatorResponse : false);
        setShowFirstNameError(typeof validatorResponse === 'boolean' ? false : true);
        setFirstNameError(typeof validatorResponse === 'string' ? validatorResponse : '');
    }, [firstNameValidator, setIsFirstNameValid, setShowFirstNameError, setFirstNameError]);
    var validateLastName = (0, react_1.useCallback)(function (lastName) {
        var validatorResponse = lastNameValidator(lastName);
        setIsLastNameValid(typeof validatorResponse === 'boolean' ? validatorResponse : false);
        setShowLastNameError(typeof validatorResponse === 'boolean' ? false : true);
        setLastNameError(typeof validatorResponse === 'string' ? validatorResponse : '');
    }, [lastNameValidator, setIsLastNameValid, setShowLastNameError, setLastNameError]);
    var onFirstNameChange = (0, react_1.useCallback)(function (firstName) {
        setFirstNameInput(firstName);
        if (firstNameValidator) {
            validateFirstName(firstName);
        }
        else {
            setIsFirstNameValid(true);
        }
    }, [firstNameValidator, validateFirstName]);
    var onLastNameChange = (0, react_1.useCallback)(function (lastName) {
        setLastNameInput(lastName);
        if (lastNameValidator) {
            validateLastName(lastName);
        }
        else {
            setIsLastNameValid(true);
        }
    }, [lastNameValidator, validateLastName]);
    (0, react_1.useEffect)(function () {
        if (firstNameInput && lastNameInput) {
            if (firstNameValidator) {
                validateFirstName(firstNameInput);
            }
            if (lastNameValidator) {
                validateLastName(lastNameInput);
            }
            setIsFormValid(isFirstNameValid && isLastNameValid);
        }
    }, [
        firstNameInput,
        lastNameInput,
        firstNameValidator,
        lastNameValidator,
        validateFirstName,
        validateLastName,
        setIsFormValid,
        isFirstNameValid,
        isLastNameValid,
    ]);
    return (react_1.default.createElement(WorkflowCard_1.WorkflowCard, __assign({}, cardBaseProps),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardBody, null,
            react_1.default.createElement(WorkflowCard_1.WorkflowCardInstructions, __assign({}, instructionsProps, { divider: true })),
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(TextField_1.default, __assign({ id: "first", fullWidth: true, variant: "filled" }, firstNameTextFieldProps, { inputRef: firstNameRef, label: firstNameLabel, value: firstNameInput, onChange: function (e) { return onFirstNameChange(e.target.value); }, onKeyUp: function (e) {
                        if (e.key === 'Enter' && lastNameRef.current)
                            lastNameRef.current.focus();
                    }, error: showFirstNameError, helperText: firstNameError, sx: {
                        mb: { md: 0, sm: 1, xs: 4 },
                    } })),
                react_1.default.createElement(TextField_1.default, __assign({ id: "last", fullWidth: true, variant: "filled", sx: {
                        mt: { md: 4, sm: 3 },
                    } }, lastNameTextFieldProps, { inputRef: lastNameRef, label: lastNameLabel, value: lastNameInput, onChange: function (e) { return onLastNameChange(e.target.value); }, onKeyUp: function (e) {
                        if (e.key === 'Enter' && isFormValid && actionsProps.canGoNext)
                            actionsProps.onNext();
                    }, error: showLastNameError, helperText: lastNameError })))),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardActions, __assign({}, actionsProps, { canGoNext: actionsProps.canGoNext && isFirstNameValid && isLastNameValid, divider: true }))));
};
exports.AccountDetailsScreenBase = AccountDetailsScreenBase;
