import React from 'react';
import { ContactScreenProps } from './types';
/**
 * Component renders a screen with contact information for support with the application.
 * Contact information is pulled from the context passed into the workflow.
 *
 * @param title to display in the header
 * @param icon to display in the icon
 * @param description to display the contact support content
 * @param contactEmail to display the contact email
 * @param contactPhone to display contact phone number
 * @param dismissButtonLabel to display label text in button
 * @param onDismiss function to call when user clicks button
 * @param slots used for each slot in `ContactScreen`
 * @param slotProps applied to each slot
 *
 * @category Component
 */
export declare const ContactSupportScreen: React.FC<ContactScreenProps>;
