"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EulaScreenBase = void 0;
var react_1 = __importStar(require("react"));
var WorkflowCard_1 = require("../../components/WorkflowCard");
var FormControlLabel_1 = __importDefault(require("@mui/material/FormControlLabel"));
var Checkbox_1 = __importDefault(require("@mui/material/Checkbox"));
var Box_1 = __importDefault(require("@mui/material/Box"));
var dompurify_1 = __importDefault(require("dompurify"));
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
/**
 * Component that renders a screen displaying the EULA and requests acceptance via a checkbox.
 *
 * @param eulaContent the content to render for the EULA. Can be a plain string or HTML
 * @param htmlEula true if the EULA should be rendered as HTML
 * @param checkboxLabel label for the EULA checkbox
 * @param initialCheckboxValue used to pre-populate the checked/unchecked checkbox when the screen loads
 * @param checkboxProps used to set checkbox props
 * @category Component
 */
var EulaScreenBase = function (props) {
    var _a;
    var _b = props.onEulaAcceptedChange, onEulaAcceptedChange = _b === void 0 ? function (accepted) { return accepted; } : _b, eulaContent = props.eulaContent, checkboxLabel = props.checkboxLabel, htmlEula = props.htmlEula, initialCheckboxValue = props.initialCheckboxValue, checkboxProps = props.checkboxProps, errorDisplayConfig = props.errorDisplayConfig;
    var cardBaseProps = props.WorkflowCardBaseProps || {};
    var headerProps = props.WorkflowCardHeaderProps || {};
    var actionsProps = props.WorkflowCardActionsProps || {};
    var _c = (0, react_1.useState)((_a = onEulaAcceptedChange(initialCheckboxValue)) !== null && _a !== void 0 ? _a : false), eulaAccepted = _c[0], setEulaAccepted = _c[1];
    var handleEulaAcceptedChecked = (0, react_1.useCallback)(function (accepted) {
        setEulaAccepted(onEulaAcceptedChange(accepted));
    }, [onEulaAcceptedChange]);
    var handleOnNext = function () {
        var onNext = actionsProps.onNext;
        if (onNext)
            onNext({ accepted: eulaAccepted });
    };
    return (react_1.default.createElement(WorkflowCard_1.WorkflowCard, __assign({}, cardBaseProps),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardBody, null,
            !htmlEula && react_1.default.createElement(Box_1.default, { sx: { flex: '1 1 0px', overflow: 'auto' } }, eulaContent),
            htmlEula && (react_1.default.createElement(Box_1.default, { sx: { flex: '1 1 0px', overflow: 'auto' }, dangerouslySetInnerHTML: { __html: dompurify_1.default.sanitize(eulaContent) } })),
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(FormControlLabel_1.default, { control: react_1.default.createElement(Checkbox_1.default, __assign({ color: 'primary', checked: eulaAccepted, onChange: function (event) {
                            return handleEulaAcceptedChecked(event.target.checked);
                        } }, checkboxProps)), label: checkboxLabel, sx: { flex: '0 0 auto', mr: 0, mt: 2 }, onKeyUp: function (e) {
                        if (e.key === 'Enter' && eulaAccepted)
                            handleOnNext();
                    } }))),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardActions, __assign({ divider: true }, actionsProps, { canGoNext: eulaAccepted && actionsProps.canGoNext }))));
};
exports.EulaScreenBase = EulaScreenBase;
